#ifndef _ITEMARRAY_
#define _ITEMARRAY_

using namespace std;

typedef int Item;

class Itemarray {
public:
  Item *items;
  int n;
  
  Itemarray(int n) { this->n=n; items=new Item[n]; }
  ~Itemarray() { delete [] items; }

  bool operator<(const Itemarray& in) const { 
    for(int i=0; i<n && i<in.n; ++i)
      if(items[i]<in.items[i]) return true;
      else if(items[i]>in.items[i]) return false;

    return false;
  }
};

Itemarray *intersection(const Itemarray* in1, const Itemarray* in2);

ostream& operator<<(ostream& os, const pair<Itemarray*,int>& out);

istream& operator>>(istream& is, pair<Itemarray*,int>& in);


struct CardLex {
  bool operator()(const Itemarray& in1, const Itemarray& in2) {
    return in1.n==in2.n ? in1<in2 : in1.n<in2.n;
  }
  bool operator()(const Itemarray* in1, const Itemarray* in2) {
    return in1->n==in2->n ? *in1<*in2 : in1->n<in2->n;
  }
};

struct CocardColex {
  bool operator()(const Itemarray* in1, const Itemarray* in2) {
    return in1->n==in2->n ? *in2<*in1 : in2->n<in1->n;
  }
};

#endif
