#ifndef _ITEMARRAY_INPUT_
#define _ITEMARRAY_INPUT_

#include <fstream>
#include <set>
#include <vector>
#include <map>
#include "itemarray.hh"

using namespace std;

class ItemarrayFileInput {
  ifstream fin;

  void initSupps();
public:
  int totsupp;
  int remsupp;
  int minsupp;
  int maxsupp;

  vector<int> supps;
  vector<int> remsupps;
  vector<bool> frequent;

  ItemarrayFileInput(char*, int =0, int =0);
  ~ItemarrayFileInput() { fin.close(); }

  pair<Itemarray *,int>* getItemarray();
};

class ItemarrayMemoryInput {
  map<Itemarray*,int,CMP> itemarrays;

  typedef map<Itemarray*,int,CMP>::iterator iterator;

  iterator cur;

public:
  int totsupp;
  int remsupp;
  int minsupp;
  int maxsupp;

  vector<int> supps;
  vector<int> remsupps;
  vector<bool> frequent;

  ItemarrayMemoryInput(char*, int =0, int =0);
  ~ItemarrayMemoryInput() { }

  pair<Itemarray *,int>* getItemarray();
};

#endif
